/* PRIME TWINS
 *
 * primes.sync.c     standard method, synchronous implementation
 * overhead of synchronous loop and load imbalance of different
 * iterations should make this an inefficient solution
 */

#include <fork.h>
#include <io.h>
#include <stdlib.h>
#include <math.h>

#define N 10000

int isprime( int z )
{
  int i;
  /* if (z%2) return 0;   not required; z is always odd */
  for (i=3; i*i<=z; i+=2)
     if (!(z%i))  return 0;
  return 1;
}

sh int cnt = 0;

main()
{
  int z;
  int i;

 if ($==0)
    pprintf("Prime Twins, range 1...%d\n", N);
 start 
  for (i=$+1; 6*i<N; i+=__STARTED_PROCS__) {
    z = 6*i - 1;
    farm
      if (isprime( z ) && isprime( z+2 )) {
         mpadd(&cnt,1);
         pprintf(" %d, %d ", z, z+2);
      }
  }
  barrier;
  if ($==0)
     pprintf("\n These are %d pairs of Prime Twins.\n", cnt);
  barrier;
  exit(0);
}
